/******************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* Ƽå */
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <fcntl.h>
#include "jyu.h"

static int dialog_loop_msg=0, ok_button=0;

/********************************************************/
/* ok_callback */
void ok_callback (GtkWidget *widget, gpointer data)
{
  dialog_loop_msg=0;
  ok_button=1;
}

/********************************************************/
/* cancel_cllback */
void cancel_callback (GtkWidget *widget, gpointer data)
{
  dialog_loop_msg=0;
  ok_button=0;
}

/***********************************************/
/* 顼å */
void err_msg(GtkWidget *main_window, char *msg)
{
  GtkWidget *window;
  GtkWidget *label;
  GtkWidget *button;

  gtk_widget_set_sensitive(main_window, 0);

  window = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window), "Ͽ");
  label = gtk_label_new (msg);
  gtk_misc_set_padding (GTK_MISC(label), 20, 20);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->vbox), label,
		      TRUE, TRUE, 0);
  gtk_widget_show (label);

  button = gtk_button_new_with_label ("  OK  ");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->action_area), button, 
		      FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC(ok_callback), NULL);
  gtk_widget_show (button);
  gtk_widget_show (window);

  dialog_loop_msg=1;
  while(dialog_loop_msg)
    gtk_main_iteration();

  gtk_widget_destroy(window);

  gtk_widget_set_sensitive(main_window, 1);
}

/************************************************/
/* Yes=1 No=0 */
int yesno_msg(GtkWidget *main_window, char *msg)
{
  GtkWidget *window;
  GtkWidget *label;
  GtkWidget *button;

  gtk_widget_set_sensitive(main_window, 0);

  window = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window), "Ͽ");
  label = gtk_label_new (msg);
  gtk_misc_set_padding (GTK_MISC(label), 20, 20);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->vbox), label,
		      TRUE, TRUE, 0);
  gtk_widget_show (label);

  button = gtk_button_new_with_label ("  Ϥ  ");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->action_area), button, 
		      FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC(ok_callback), NULL);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("  ");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->action_area), button, 
		      FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC(cancel_callback), NULL);
  gtk_widget_show (button);

  gtk_widget_show (window);

  ok_button=0;
  dialog_loop_msg=1;
  while(dialog_loop_msg)
    gtk_main_iteration();

  gtk_widget_destroy(window);
  gtk_widget_set_sensitive(main_window, 1);

  return ok_button;
}
 
