/******************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* Ƽå */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "jyu.h"

static int destroy_on, dialog_loop, ok_button;
static int ji_atena_fg, ka_atena_fg;

/********************************************************/
/*  ̾ */
void ji_atena_cb (GtkWidget *widget, gpointer data)
{
  if (GTK_TOGGLE_BUTTON (widget)->active)
    ji_atena_fg=1;
  else
    ji_atena_fg=0;
}

/********************************************************/
/*  ̾ */
void ka_atena_cb (GtkWidget *widget, gpointer data)
{
  if (GTK_TOGGLE_BUTTON (widget)->active)
    ka_atena_fg=1;
  else
    ka_atena_fg=0;
}

/********************************************************/
/* ok_callback */
static void ok_cb(GtkWidget *widget, gpointer data)
{
  dialog_loop=0;
  ok_button=1;
}

/********************************************************/
/* cancel_cllback */
static void cancel_cb(GtkWidget *widget, gpointer data)
{
  dialog_loop=0;
  ok_button=0;
}

/*******************************************************/
/* destroy */
static void destroy_cb(GtkWidget *widget, gpointer data)
{
  dialog_loop=0;
  destroy_on=1;
}

/*******************************************************/
/* ϥեɺ */
GtkWidget *create_field(GtkWidget *hbox, char *lname)
{
  GtkWidget *label, *wk;

  if (lname){
    label=gtk_label_new(lname);
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 10);
    gtk_widget_show(label);
  }
  wk=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox), wk, TRUE, TRUE, 0);
  gtk_widget_show(wk);
  return wk;
}

/*******************************************************/
/** hbox  **/
GtkWidget *create_hbox(GtkWidget *vbox)
{
  GtkWidget *hbox;

  hbox=gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  return hbox;
}

/** ɾ **********************************************/
/**                                                  **/
GtkWidget *create_keisyou(GtkWidget *hbox, char *la)
{
  GtkWidget *k, *label;

  label=gtk_label_new(la);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 10);
  gtk_widget_show(label);
  k=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox), k, FALSE, FALSE, 0);
  gtk_widget_show(k);
  return k;
}

/** Խ ***********************************************/
/** fg 0=ɲ 1= 2=                            **/
/** ret 0=ok 1=cancel                                 **/
int addr_edit(GtkWidget *p_win, int key, int fg, JYU *jyu_p, char *apend_yomi)
{
  static char *wtitle[3]={"ɲ", "", ""};

  GtkWidget *window, *vbox, *hbox, *label;
  GtkWidget *button;
  GtkWidget *yomi, *bkey, *namae, *umare, *bikou;
  GtkWidget *jitaku1, *jitaku2, *ji_yubin, *ji_mail1, *ji_mail2, *ji_www, *ji_tel, *ji_keitai;
  GtkWidget *ji_ren1, *ji_ren2, *ji_ren3, *ji_ren4, *ji_keisyou, *ji_atena;
  GtkWidget *kaisya1, *kaisya2, *ka_katagaki, *ka_yubin, *ka_mail1, *ka_mail2, *ka_www;
  GtkWidget *ka_tel, *ka_keitai, *ka_keisyou, *ka_atena;
  JYU jyu;

  gtk_widget_set_sensitive(p_win, 0);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window),  wtitle[fg]);
  gtk_container_border_width (GTK_CONTAINER (window), 10);
  gtk_signal_connect(GTK_OBJECT(window), "destroy", 
		     GTK_SIGNAL_FUNC(destroy_cb), NULL);

  vbox=gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add (GTK_CONTAINER(window), vbox);

  hbox=create_hbox(vbox);
  yomi=create_field(hbox, "  ");
  bkey=create_field(hbox, "ʬ७");
  gtk_window_set_focus (GTK_WINDOW (window), GTK_WIDGET(yomi));

  hbox=create_hbox(vbox);
  namae=create_field(hbox, "̾  ");
  umare=create_field(hbox, "ǯ");
  
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox=create_hbox(vbox);
  jitaku1=create_field(hbox, "  ");
  hbox=create_hbox(vbox); 
  jitaku2=create_field(hbox, "      ");
  hbox=create_hbox(vbox);
  ji_mail1=create_field(hbox, "E-Mail");
  ji_mail2=create_field(hbox, NULL);
  ji_www=create_field(hbox, "www");
  hbox=create_hbox(vbox);
  ji_yubin=create_field(hbox, "͹ֹ");
  ji_tel=create_field(hbox, "TEL");
  ji_keitai=create_field(hbox, "");
  hbox=create_hbox(vbox);
  ji_ren1=create_field(hbox, "Ϣ  ̾");
  ji_ren2=create_field(hbox, NULL);
  ji_ren3=create_field(hbox, NULL);
  ji_ren4=create_field(hbox, NULL);
  hbox=create_hbox(vbox);
  ji_keisyou=create_keisyou(hbox, "  ");
  ji_atena=gtk_check_button_new_with_label("̾");
  gtk_box_pack_start(GTK_BOX(hbox), ji_atena, FALSE, FALSE, 10);
  gtk_signal_connect (GTK_OBJECT(ji_atena), "clicked", GTK_SIGNAL_FUNC(ji_atena_cb), NULL);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ji_atena), FALSE);
  ji_atena_fg=0;

  if (2!=fg)
    gtk_widget_show(ji_atena);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox=create_hbox(vbox);
  kaisya1=create_field(hbox, "  ");
  hbox=create_hbox(vbox);
  kaisya2=create_field(hbox, "      ");
  hbox=create_hbox(vbox);
  ka_katagaki=create_field(hbox, "  ");
  hbox=create_hbox(vbox);
  ka_mail1=create_field(hbox, "E-Mail");
  ka_mail2=create_field(hbox, NULL);
  ka_www=create_field(hbox, "www");
  hbox=create_hbox(vbox);
  ka_yubin=create_field(hbox, "͹ֹ");
  ka_tel=create_field(hbox, "TEL");
  ka_keitai=create_field(hbox, "");
  hbox=create_hbox(vbox);
  ka_keisyou=create_keisyou(hbox, "  ");
  ka_atena=gtk_check_button_new_with_label("̾");
  gtk_box_pack_start(GTK_BOX(hbox), ka_atena, FALSE, FALSE, 10);
  gtk_signal_connect (GTK_OBJECT(ka_atena), "clicked", GTK_SIGNAL_FUNC(ka_atena_cb), NULL);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ka_atena), FALSE);
  ka_atena_fg=0;

  if (2!=fg)
    gtk_widget_show(ka_atena);
 
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox=create_hbox(vbox);
  bikou=create_field(hbox, "  ");

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox=create_hbox(vbox);

  label=gtk_label_new("        TAB,up,downǥեɰư");
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 10);
  gtk_widget_show(label);

  button = gtk_button_new_with_label("󥻥");
  gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 10);
  gtk_signal_connect (GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(cancel_cb), NULL);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("    OK    ");
  gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 10);
  gtk_signal_connect (GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(ok_cb), NULL);
  gtk_widget_show(button);

  gtk_widget_show(window);

  if (0==fg)
    gtk_entry_set_text(GTK_ENTRY(yomi), apend_yomi);

  if (1==fg){
    if (1==(ji_atena_fg=jyu_p->ji_atena))
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ji_atena), TRUE);
    else
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ji_atena), FALSE);
    if (1==(ka_atena_fg=jyu_p->ka_atena))
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ka_atena), TRUE);
    else
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ka_atena), FALSE);

    gtk_entry_set_text(GTK_ENTRY(yomi), jyu_p->yomi);
    gtk_entry_set_text(GTK_ENTRY(bkey), jyu_p->bkey);
    gtk_entry_set_text(GTK_ENTRY(namae), jyu_p->namae);
    gtk_entry_set_text(GTK_ENTRY(umare), jyu_p->umare);
    gtk_entry_set_text(GTK_ENTRY(jitaku1), jyu_p->jitaku1);
    gtk_entry_set_text(GTK_ENTRY(jitaku2), jyu_p->jitaku2);
    gtk_entry_set_text(GTK_ENTRY(ji_yubin), jyu_p->ji_yubin);
    gtk_entry_set_text(GTK_ENTRY(ji_mail1), jyu_p->ji_mail1);
    gtk_entry_set_text(GTK_ENTRY(ji_mail2), jyu_p->ji_mail2);
    gtk_entry_set_text(GTK_ENTRY(ji_www), jyu_p->ji_www);
    gtk_entry_set_text(GTK_ENTRY(ji_tel), jyu_p->ji_tel);
    gtk_entry_set_text(GTK_ENTRY(ji_keitai), jyu_p->ji_keitai);
    gtk_entry_set_text(GTK_ENTRY(ji_ren1), jyu_p->ji_ren1);
    gtk_entry_set_text(GTK_ENTRY(ji_ren2), jyu_p->ji_ren2);
    gtk_entry_set_text(GTK_ENTRY(ji_ren3), jyu_p->ji_ren3);
    gtk_entry_set_text(GTK_ENTRY(ji_ren4), jyu_p->ji_ren4);
    gtk_entry_set_text(GTK_ENTRY(ji_keisyou), jyu_p->ji_keisyou);
    gtk_entry_set_text(GTK_ENTRY(kaisya1), jyu_p->kaisya1);
    gtk_entry_set_text(GTK_ENTRY(kaisya2), jyu_p->kaisya2);
    gtk_entry_set_text(GTK_ENTRY(ka_katagaki), jyu_p->ka_katagaki);
    gtk_entry_set_text(GTK_ENTRY(ka_yubin), jyu_p->ka_yubin);
    gtk_entry_set_text(GTK_ENTRY(ka_mail1), jyu_p->ka_mail1);
    gtk_entry_set_text(GTK_ENTRY(ka_mail2), jyu_p->ka_mail2);
    gtk_entry_set_text(GTK_ENTRY(ka_www), jyu_p->ka_www);
    gtk_entry_set_text(GTK_ENTRY(ka_tel), jyu_p->ka_tel);
    gtk_entry_set_text(GTK_ENTRY(ka_keitai), jyu_p->ka_keitai);
    gtk_entry_set_text(GTK_ENTRY(ka_keisyou), jyu_p->ka_keisyou);
    gtk_entry_set_text(GTK_ENTRY(bikou), jyu_p->bikou);
  }

  destroy_on=0;
  ok_button=0;
  dialog_loop=1;
  while(dialog_loop)
    gtk_main_iteration();

  if (ok_button){
    memset(&jyu, 0, sizeof(JYU));
    jyu.key=key;
    jyu.ji_atena=ji_atena_fg;
    jyu.ka_atena=ka_atena_fg;
    strncpy(jyu.yomi, gtk_entry_get_text(GTK_ENTRY(yomi)), sizeof(jyu.yomi));
    strncpy(jyu.bkey, gtk_entry_get_text(GTK_ENTRY(bkey)), sizeof(jyu.bkey));
    strncpy(jyu.namae, gtk_entry_get_text(GTK_ENTRY(namae)), sizeof(jyu.namae));
    strncpy(jyu.umare, gtk_entry_get_text(GTK_ENTRY(umare)), sizeof(jyu.umare));
    strncpy(jyu.jitaku1, gtk_entry_get_text(GTK_ENTRY(jitaku1)), sizeof(jyu.jitaku1));
    strncpy(jyu.jitaku2, gtk_entry_get_text(GTK_ENTRY(jitaku2)), sizeof(jyu.jitaku2));
    strncpy(jyu.ji_yubin, gtk_entry_get_text(GTK_ENTRY(ji_yubin)), sizeof(jyu.ji_yubin));
    strncpy(jyu.ji_mail1, gtk_entry_get_text(GTK_ENTRY(ji_mail1)), sizeof(jyu.ji_mail1));
    strncpy(jyu.ji_mail2, gtk_entry_get_text(GTK_ENTRY(ji_mail2)), sizeof(jyu.ji_mail2));
    strncpy(jyu.ji_www, gtk_entry_get_text(GTK_ENTRY(ji_www)), sizeof(jyu.ji_www));
    strncpy(jyu.ji_tel, gtk_entry_get_text(GTK_ENTRY(ji_tel)), sizeof(jyu.ji_tel));
    strncpy(jyu.ji_keitai, gtk_entry_get_text(GTK_ENTRY(ji_keitai)), sizeof(jyu.ji_keitai));
    strncpy(jyu.ji_ren1, gtk_entry_get_text(GTK_ENTRY(ji_ren1)), sizeof(jyu.ji_ren1));
    strncpy(jyu.ji_ren2, gtk_entry_get_text(GTK_ENTRY(ji_ren2)), sizeof(jyu.ji_ren2));
    strncpy(jyu.ji_ren3, gtk_entry_get_text(GTK_ENTRY(ji_ren3)), sizeof(jyu.ji_ren3));
    strncpy(jyu.ji_ren4, gtk_entry_get_text(GTK_ENTRY(ji_ren4)), sizeof(jyu.ji_ren4));
    strncpy(jyu.ji_keisyou, gtk_entry_get_text(GTK_ENTRY(ji_keisyou)), sizeof(jyu.ji_keisyou));
    strncpy(jyu.kaisya1, gtk_entry_get_text(GTK_ENTRY(kaisya1)), sizeof(jyu.kaisya1));
    strncpy(jyu.kaisya2, gtk_entry_get_text(GTK_ENTRY(kaisya2)), sizeof(jyu.kaisya2));
    strncpy(jyu.ka_katagaki, gtk_entry_get_text(GTK_ENTRY(ka_katagaki)), sizeof(jyu.ka_katagaki));
    strncpy(jyu.ka_yubin, gtk_entry_get_text(GTK_ENTRY(ka_yubin)), sizeof(jyu.ka_yubin));
    strncpy(jyu.ka_mail1, gtk_entry_get_text(GTK_ENTRY(ka_mail1)), sizeof(jyu.ka_mail1));
    strncpy(jyu.ka_mail2, gtk_entry_get_text(GTK_ENTRY(ka_mail2)), sizeof(jyu.ka_mail2));
    strncpy(jyu.ka_www, gtk_entry_get_text(GTK_ENTRY(ka_www)), sizeof(jyu.ka_www));
    strncpy(jyu.ka_tel, gtk_entry_get_text(GTK_ENTRY(ka_tel)), sizeof(jyu.ka_tel));
    strncpy(jyu.ka_keitai, gtk_entry_get_text(GTK_ENTRY(ka_keitai)), sizeof(jyu.ka_keitai));
    strncpy(jyu.ka_keisyou, gtk_entry_get_text(GTK_ENTRY(ka_keisyou)), sizeof(jyu.ka_keisyou));
    strncpy(jyu.bikou, gtk_entry_get_text(GTK_ENTRY(bikou)), sizeof(jyu.bikou));
    switch (fg){
    case 0:
      data_add(jyu);
      break;
    case 1:
      data_updt(jyu, jyu_p);
      break;
    case 2:
      *jyu_p=jyu;
      break;
    }
  }

  if (!destroy_on)
    gtk_widget_destroy(window);

  gtk_widget_set_sensitive(p_win, 1);

  return ok_button;
}
