/******************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/*  */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "jyu.h"

extern JYU *jyu_end;

/**  ******************************************/
/** ret 1=Ʊ 0=㤦                                **/
static int chk_sub(char *s1, char *s2)
{
  if (0==strlen(s1) || 0==strlen(s2))
    return 0;

  if (NULL==strstr(s1, s2))
    return 0;
  else
    return 1;
}

/**  **********************************************/
/** ret 1>0ͭ 0=ʤ                                **/
static int dt_chk(JYU *jyu_t, JYU *jyu_k)
{
  int fg;

  fg=0;

  fg+=chk_sub(jyu_t->yomi, jyu_k->yomi);
  fg+=chk_sub(jyu_t->bkey, jyu_k->bkey);
  fg+=chk_sub(jyu_t->namae, jyu_k->namae);
  fg+=chk_sub(jyu_t->umare, jyu_k->umare);
  fg+=chk_sub(jyu_t->jitaku1, jyu_k->jitaku1);
  fg+=chk_sub(jyu_t->jitaku2, jyu_k->jitaku2);
  fg+=chk_sub(jyu_t->ji_yubin, jyu_k->ji_yubin);
  fg+=chk_sub(jyu_t->ji_mail1, jyu_k->ji_mail1);
  fg+=chk_sub(jyu_t->ji_mail2, jyu_k->ji_mail2);
  fg+=chk_sub(jyu_t->ji_www, jyu_k->ji_www);
  fg+=chk_sub(jyu_t->ji_tel, jyu_k->ji_tel);
  fg+=chk_sub(jyu_t->ji_keitai, jyu_k->ji_keitai);
  fg+=chk_sub(jyu_t->ji_ren1, jyu_k->ji_ren1);
  fg+=chk_sub(jyu_t->ji_ren2, jyu_k->ji_ren2);
  fg+=chk_sub(jyu_t->ji_ren3, jyu_k->ji_ren3);
  fg+=chk_sub(jyu_t->ji_ren4, jyu_k->ji_ren4);
  fg+=chk_sub(jyu_t->ji_keisyou, jyu_k->ji_keisyou);
  fg+=chk_sub(jyu_t->kaisya1, jyu_k->kaisya1);
  fg+=chk_sub(jyu_t->kaisya2, jyu_k->kaisya2);
  fg+=chk_sub(jyu_t->ka_katagaki, jyu_k->ka_katagaki);
  fg+=chk_sub(jyu_t->ka_yubin, jyu_k->ka_yubin);
  fg+=chk_sub(jyu_t->ka_mail1, jyu_k->ka_mail1);
  fg+=chk_sub(jyu_t->ka_mail2, jyu_k->ka_mail2);
  fg+=chk_sub(jyu_t->ka_www, jyu_k->ka_www);
  fg+=chk_sub(jyu_t->ka_tel, jyu_k->ka_tel);
  fg+=chk_sub(jyu_t->ka_keitai, jyu_k->ka_keitai);
  fg+=chk_sub(jyu_t->ka_keisyou, jyu_k->ka_keisyou);
  fg+=chk_sub(jyu_t->bikou, jyu_k->bikou);

  return fg;
}  

/**ɽ*****************************************/
/**                                                  **/
void sach_main(GtkWidget *clist, JYU jyu_k)
{
  gchar *dt[4];
  JYU *jyu_p, *jwk;
  int row, cnt;

  cnt=0;
  jyu_p=jyu_end;
  while(jyu_p){
    if (0==jyu_p->del && dt_chk(jyu_p, &jyu_k)){
      jyu_p->sach=1;
      cnt++;
    }else
      jyu_p->sach=0;
    jyu_p=jyu_p->pb;
  }
  jwk=(JYU *)malloc(sizeof(JYU)*cnt);

  cnt=0;
  jyu_p=jyu_end;
  while(jyu_p){
    if (jyu_p->sach)
      jwk[cnt++]=(*jyu_p);
    jyu_p=jyu_p->pb;
  }
  qsort(jwk, cnt, sizeof(JYU), list_compar); /**/  

  gtk_clist_clear((GtkCList*)clist);  /*ꥹȤ򥯥䡼*/

  row=0;
  for (row=0; row<cnt; row++){
    dt[0]=jwk[row].namae;
    dt[1]=jwk[row].ji_mail1;
    dt[2]=jwk[row].ji_tel;
    dt[3]=jwk[row].ji_keitai;
    gtk_clist_append((GtkCList*)clist, dt);  /**/
    gtk_clist_set_row_data((GtkCList*)clist, row, (gpointer)(jwk[row].myself));
  }
  free(jwk);
}

/**̤κɽ**************************************/
/**                                                  **/
void sach_review(GtkWidget *clist)
{
  gchar *dt[4];
  JYU *jyu_p, *jwk;
  int row, cnt;

  cnt=0;
  jyu_p=jyu_end;
  while(jyu_p){
    if (0==jyu_p->del && jyu_p->sach)
      cnt++;
    jyu_p=jyu_p->pb;
  }
  jwk=(JYU *)malloc(sizeof(JYU)*cnt);

  cnt=0;
  jyu_p=jyu_end;
  while(jyu_p){
    if (0==jyu_p->del && jyu_p->sach)
      jwk[cnt++]=(*jyu_p);
    jyu_p=jyu_p->pb;
  }
  qsort(jwk, cnt, sizeof(JYU), list_compar); /**/  

  gtk_clist_clear((GtkCList*)clist);  /*ꥹȤ򥯥䡼*/

  row=0;
  for (row=0; row<cnt; row++){
    dt[0]=jwk[row].namae;
    dt[1]=jwk[row].ji_mail1;
    dt[2]=jwk[row].ji_tel;
    dt[3]=jwk[row].ji_keitai;
    gtk_clist_append((GtkCList*)clist, dt);  /**/
    gtk_clist_set_row_data((GtkCList*)clist, row, (gpointer)(jwk[row].myself));
  }
  free(jwk);
}
