/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "jyu.h"

static char *aiu[]={"","","","","", "","","","","",
             "","","","","", "","","","","",
	     "","","","","", "","","","","",
	     "","","","","", "","  ","","  ","",
             "","","","","", "","","","  ","  "};
static char *abc[]={"a ","b ","c ","d ","e ","f ","g ",
             "h ","i ","j ","k ","l ","m ","n ",
             "o ","p ","q ","r ","s ","t ","u ",
             "v ","w ","x ","y ","z ","  ","  "};

GtkWidget *main_window, *clist1;
int key=100;
JYU *actv_jyu_p=NULL;
int kensaku_on=0;

/***************************************************/
/* λǧ                                         */
static void quit_cb(GtkWidget *widget, gpointer data)
{
  if (1==yesno_msg(main_window, "λƤ⤤Ǥ")){
    data_save(JYUROKU_DAT);
    gtk_exit(0);
  }  
}

/***************************************************/
/* λǧ                                         */
gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  if (1==yesno_msg(main_window, "λƤ⤤Ǥ")){
    data_save(JYUROKU_DAT);
    return FALSE;
  }
  return TRUE;  
}

/***************************************************/
/* λ                                            */
void destroy (GtkWidget *widget, gpointer data)
{
  gtk_main_quit();
}

/***************************************************/
/* aiuܥ                                        */
static void aiu_btn_cb(GtkWidget *widget, gpointer data)
{
  char wk[20];

  key=(int)data;
  data_clist_set(clist1, key);
  
  if (200 > key)
    sprintf(wk, "̾ %s", aiu[key-100]);
  else
    sprintf(wk, "̾ (%c)", abc[key-200][0]);

  gtk_clist_set_column_title(GTK_CLIST(clist1), 0, wk);
  actv_jyu_p=NULL;
  kensaku_on=0;
}

/***************************************************/
/* ɲåܥ                                       */
static void append_cb(GtkWidget *widget, gpointer data)
{
  char wk[3];

  if (kensaku_on){
    err_msg(main_window, "֤ǤɲäϤǤޤ");
    return;
  }

  memset(wk, 0, sizeof(wk));

  if (200>key)
    strncpy(wk, aiu[key-100], 2);
  else
    strncpy(wk, abc[key-200], 1);

  addr_edit(main_window, key, 0, NULL, wk);
  data_clist_set(clist1, key);
  actv_jyu_p=NULL;
}

/***************************************************/
/* Խܥ                                       */
static void edit_cb(GtkWidget *widget, gpointer data)
{
  if (actv_jyu_p){
    addr_edit(main_window, actv_jyu_p->key, 1, actv_jyu_p, "");
    if (kensaku_on)
      sach_review(clist1);
    else
      data_clist_set(clist1, actv_jyu_p->key);
    actv_jyu_p=NULL;
  }else
    err_msg(main_window,"̾򤵤Ƥޤ");
}

/***************************************************/
/* õܥ                                       */
static void del_cb(GtkWidget *widget, gpointer data)
{
  if (actv_jyu_p){
    if (1==yesno_msg(main_window, "õƤ⤤Ǥ")){
      data_del(actv_jyu_p);
      data_clist_set(clist1, key);
      actv_jyu_p=NULL;
    }
  }else
    err_msg(main_window,"õ̾򤵤Ƥޤ");

}

/***************************************************/
/*                                             */
static void sach_cb(GtkWidget *widget, gpointer data)
{
  JYU jyu;

  if (addr_edit(main_window, key, 2, &jyu, "")){
    sach_main(clist1, jyu);
    gtk_clist_set_column_title(GTK_CLIST(clist1), 0, "̾ʸ");
    actv_jyu_p=NULL;
    kensaku_on=1;
  }
}

/***************************************************/
/* ɽܥ                                   */
static void sach_review_btn_cb(GtkWidget *widget, gpointer data)
{
  sach_review(clist1);
  gtk_clist_set_column_title(GTK_CLIST(clist1), 0, "̾ʸ");
  actv_jyu_p=NULL;
  kensaku_on=1;
}

/***************************************************/
/* ̾                                            */
static void atena_cb(GtkWidget *widget, gpointer data)
{
  int wk;

  wk=(int)data;

  if (3==wk && NULL==actv_jyu_p){
    err_msg(main_window, "̾򤵤Ƥޤ");
    return;
  }

  if (1<=wk && 3>=wk)
    if (0==yesno_msg(main_window, "򳫻ϤƤ⤤Ǥ"))
      return;
  
  switch ((int)data){
  case 1:
   atena_chk_on_all();
   break;
  case 2:
   atena_chk_on_sach();
   break;
  case 3:
   atena_sel_1(actv_jyu_p);
   break;
  case 4:
    break;
  case 5:
    atena_set(main_window);
    break;
  }    
}

/***************************************************/
/** ,aܥ                                 **/
void aiu_btn_create(GtkWidget *vbox)
{
  GtkWidget *hbox, *button;
  int       i, j, cnt;

  cnt=100;
  for (j=0; j<10; j++){
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
    gtk_widget_show(hbox);
    for (i=0; i<5; i++){
      button=gtk_button_new_with_label(aiu[j*5+i]);
      gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);
      gtk_signal_connect(GTK_OBJECT(button), "clicked",
                         GTK_SIGNAL_FUNC(aiu_btn_cb), (gpointer)(cnt++));
      gtk_widget_show(button);
    }
  }
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);
  cnt=200;
  for (j=0; j<4; j++){
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
    gtk_widget_show(hbox);
    for (i=0; i<7; i++){
      button=gtk_button_new_with_label(abc[j*7+i]);
      gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);
      gtk_signal_connect(GTK_OBJECT(button), "clicked",
                         GTK_SIGNAL_FUNC(aiu_btn_cb), (gpointer)(cnt++));
      gtk_widget_show(button);
    }
  }
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);
}  

/*******************************************/
/* ꥹȤ򤵤줿                        */
void list_select1(GtkWidget *clist, gint row, gint column,
		 GdkEventButton *event, gpointer data)
{
  gpointer gp;

  if (!event)
    return;

  gp=gtk_clist_get_row_data(GTK_CLIST(clist), row);
  actv_jyu_p=(JYU *)gp;
  if (GDK_2BUTTON_PRESS == event->type){
    addr_edit(main_window, actv_jyu_p->key, 1, actv_jyu_p, "");
    if (kensaku_on)
      sach_review(clist1);
    else
      data_clist_set(clist1, actv_jyu_p->key);
  }
}

/*******************************************/
/* ꥹȤ򤵤줿                      */
void list_unselect1(GtkWidget *clist, gint row, gint column,
		 GdkEventButton *event, gpointer data)
{
  actv_jyu_p=NULL;
}

/***************************************************/
/* ȥåפwindow Ƥο */
int start_window(int argc, char *argv[])
{
  gchar *menu_title[5]={ "̾ON", "̤鰸̾ON", 
                        "Σ", "----------------------------", "    "};
  gchar *title1[4] = {"̾ʤ","᡼","TEL",""};
  GtkWidget *window, *scrolled_win1;
  GtkWidget *main_vbox, *adr_hbox;
  GtkWidget *vbox1, *vbox2, *ctl_hbox;
  GtkWidget *button_append, *button_edit, *button_del, *button_sach, *button_review;
  GtkWidget *menu, *menu_items, *root_menu, *menu_bar;
  int i;

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);               /*ȥåץɥ*/
  main_window=window;
  gtk_signal_connect(GTK_OBJECT(window), "destroy", 
		     GTK_SIGNAL_FUNC(destroy), NULL);
  gtk_window_set_title(GTK_WINDOW(window), "Ͽ");
  gtk_widget_set_usize(GTK_WIDGET(window), 700, 500);
  gtk_signal_connect(GTK_OBJECT (window), "delete_event",
		     (GtkSignalFunc)delete_event, NULL);
    
  main_vbox = gtk_vbox_new(FALSE, 0);                       /*ᥤܥå*/
  gtk_container_border_width(GTK_CONTAINER(main_vbox), 1);
  gtk_container_add(GTK_CONTAINER(window), main_vbox);
  gtk_widget_show(main_vbox);

  /***˥塼 **********************************************/
  menu_bar = gtk_menu_bar_new();
  gtk_box_pack_start(GTK_BOX(main_vbox), menu_bar, FALSE, FALSE, 2);
  gtk_widget_show(menu_bar);

  menu = gtk_menu_new();
  menu_items = gtk_menu_item_new_with_label("λ");
  gtk_menu_append(GTK_MENU (menu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate", 
	             GTK_SIGNAL_FUNC(quit_cb), NULL);
  gtk_widget_show(menu_items);

  root_menu = gtk_menu_item_new_with_label("ե");
  gtk_widget_show(root_menu);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM (root_menu), menu);
  gtk_menu_bar_append(GTK_MENU_BAR (menu_bar), root_menu);

  root_menu = gtk_menu_item_new_with_label("̾");
  gtk_widget_show(root_menu);
  gtk_menu_bar_append(GTK_MENU_BAR (menu_bar), root_menu);

  menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM (root_menu), menu);

  for (i=0; i<5; i++){
    menu_items = gtk_menu_item_new_with_label(menu_title[i]);
    gtk_menu_append(GTK_MENU (menu), menu_items);
    gtk_signal_connect(GTK_OBJECT(menu_items), "activate", 
		       GTK_SIGNAL_FUNC(atena_cb), (gpointer)(i+1));
    gtk_widget_show(menu_items);
  }

  /** ȥ Υܥ *****************/
  ctl_hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(main_vbox), ctl_hbox, FALSE, FALSE, 2);
  gtk_widget_show(ctl_hbox);

  button_append = gtk_button_new_with_label(" ɲ ");
  button_edit = gtk_button_new_with_label("  ");
  button_del = gtk_button_new_with_label(" õ ");
  button_sach = gtk_button_new_with_label("  ");
  button_review=gtk_button_new_with_label("  ɽ ");

  gtk_box_pack_start(GTK_BOX(ctl_hbox), button_append, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(ctl_hbox), button_edit, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(ctl_hbox), button_del, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(ctl_hbox), button_sach, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(ctl_hbox), button_review, FALSE, FALSE, 2);

  gtk_signal_connect(GTK_OBJECT(button_append), "clicked",   /*ɲ*/
		     GTK_SIGNAL_FUNC(append_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(button_edit), "clicked",     /**/
		     GTK_SIGNAL_FUNC(edit_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(button_del), "clicked",      /**/
		     GTK_SIGNAL_FUNC(del_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(button_sach), "clicked",      /**/
		     GTK_SIGNAL_FUNC(sach_cb), NULL);
  gtk_signal_connect(GTK_OBJECT(button_review), "clicked",   /*ɽ*/
                     GTK_SIGNAL_FUNC(sach_review_btn_cb), NULL);

  gtk_widget_show(button_append);
  gtk_widget_show(button_edit);
  gtk_widget_show(button_del);
  gtk_widget_show(button_sach);
  gtk_widget_show(button_review);

 /** ꥹȤaiuܥο ***************/
  vbox1=gtk_vbox_new(FALSE, 0);
  vbox2=gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox1);
  gtk_widget_show(vbox2);

  /***ꥹ******************/
  scrolled_win1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_set_border_width (GTK_CONTAINER (scrolled_win1), 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win1),
  			  GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);

  clist1 = gtk_clist_new_with_titles(4, title1);   /*ꥹȥܥå*/
  gtk_container_add (GTK_CONTAINER (scrolled_win1), clist1);
  gtk_widget_show (scrolled_win1);

  gtk_box_pack_start(GTK_BOX(vbox1), scrolled_win1, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(clist1), "select_row",
		     GTK_SIGNAL_FUNC(list_select1),
		     NULL);
  gtk_signal_connect(GTK_OBJECT(clist1), "unselect_row",
		     GTK_SIGNAL_FUNC(list_unselect1),
		     NULL);
  gtk_clist_set_button_actions(GTK_CLIST(clist1), 1, GTK_BUTTON_SELECTS);
  gtk_clist_set_button_actions(GTK_CLIST(clist1), 2, GTK_BUTTON_SELECTS);

  gtk_clist_set_shadow_type(GTK_CLIST(clist1), GTK_SHADOW_OUT);
  gtk_clist_set_column_width (GTK_CLIST(clist1), 0, 200);
  gtk_clist_set_column_width (GTK_CLIST(clist1), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST(clist1), 2, 100);
  gtk_clist_set_column_width (GTK_CLIST(clist1), 3, 100);

  gtk_widget_show(clist1);

  /****** aiu, abc button ************/
  aiu_btn_create(vbox2);
  
  /**************************************************/
  adr_hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(main_vbox), adr_hbox, TRUE, TRUE, 2);
  gtk_box_pack_start(GTK_BOX(adr_hbox), vbox1, TRUE, TRUE, 0); /*ȥ*/
  gtk_box_pack_start(GTK_BOX(adr_hbox), vbox2, FALSE, FALSE, 0); /*ȥ*/
  gtk_widget_show(adr_hbox);
  gtk_widget_show(window);

  /** ǡɤ߹ ************************/
  if (0==data_read(JYUROKU_DAT))
    data_clist_set(clist1, key);

  gtk_main();
    
  return(0);
}

/***************************************************/
/* ᥤ */
int main(int argc, char *argv[])
{
  static char *rc_dt[5]={
    "style \"default\" ",
    "{",
    "fontset = \"-*-fixed-*-r-*-*-16-*-*-*-*-*-jisx0208.1983-*,-*-*-*-r-*-*-16-*-*-*-*-*-iso8859-*\"  ",
    "}",
    "widget_class \"*\" style \"default\" "
  };

  char *home, fname[256];
  char  jyuroku_dir[1024];
  char  rc_dir[1024];
  FILE *fp;
  int  i;

  gtk_set_locale();
  gtk_init(&argc, &argv);

  home=getenv("HOME");

  strncpy(rc_dir, home, sizeof(rc_dir)-50);
  strcat(rc_dir, "/.jyurc");
  if (0 != access(rc_dir, F_OK)){
    fp=fopen(rc_dir, "w");
    for (i=0; i<5; i++)
      fprintf(fp, "%s\n", rc_dt[i]);
    fclose(fp);
  }

  strncpy(jyuroku_dir, home, sizeof(jyuroku_dir)-50);
  strcat(jyuroku_dir, "/.jyuroku_dir");
  mkdir(jyuroku_dir, 0700);
  chdir(jyuroku_dir);

  sprintf(fname, "%s/%s", home, ".jyurc");
  gtk_rc_parse(fname);

  start_window(argc, argv);  /*ƤϤޤ*/
  return 0;
}

