/******************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* ǡ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "jyu.h"

JYU *jyu_end=NULL;

/**ǡϿ*****************************************/
/** ret NULL=err                                     **/
JYU *data_add(JYU jyu)
{
  JYU *jyu_new;

  if (NULL==(jyu_new=(JYU *)malloc(sizeof(JYU))))
    return NULL;
  memset(jyu_new, 0, sizeof(JYU));
  memcpy(jyu_new, &jyu, sizeof(JYU));
  jyu_new->myself=jyu_new;
  jyu_new->pb=jyu_end;
  jyu_end=jyu_new;
  return jyu_new;
}    

/**ǡν*****************************************/
/**                                                  **/
void data_updt(JYU jyu, JYU *jyu_p)
{
  jyu.pb=jyu_p->pb;
  jyu.myself=jyu_p->myself;
  jyu.sach=jyu_p->sach;
  memcpy(jyu_p, &jyu, sizeof(JYU));
}    

/**ǡξõ*****************************************/
/**                                                  **/
void data_del(JYU *jyu_p)
{
  jyu_p->del=1;
}    


/**************************************************/
/* ꥹȥǡΥ */
int list_compar(const void *d1, const void *d2)
{
  JYU *j1, *j2;

  j1=(JYU *)d1;
  j2=(JYU *)d2;
  return strcmp(j1->namae, j2->namae);
}

/**ǡɽ*****************************************/
/**                                                  **/
void data_clist_set(GtkWidget *clist, int key)
{
  gchar *dt[4];
  JYU *jyu_p, *jwk;
  int row, cnt;

  cnt=0;
  jyu_p=jyu_end;
  while(jyu_p){
    if (0==jyu_p->del && jyu_p->key == key)
      cnt++;
    jyu_p=jyu_p->pb;
  }
  jwk=(JYU *)malloc(sizeof(JYU)*cnt);

  cnt=0;
  jyu_p=jyu_end;
  while(jyu_p){
    if (0==jyu_p->del && jyu_p->key == key)
      jwk[cnt++]=(*jyu_p);
    jyu_p=jyu_p->pb;
  }
  qsort(jwk, cnt, sizeof(JYU), list_compar); /**/  

  gtk_clist_clear((GtkCList*)clist);  /*ꥹȤ򥯥䡼*/

  row=0;
  for (row=0; row<cnt; row++){
    dt[0]=jwk[row].namae;
    dt[1]=jwk[row].ji_mail1;
    dt[2]=jwk[row].ji_tel;
    dt[3]=jwk[row].ji_keitai;
    gtk_clist_append((GtkCList*)clist, dt);  /**/
    gtk_clist_set_row_data((GtkCList*)clist, row, (gpointer)(jwk[row].myself));
  }
  free(jwk);
}

/** PUT sub *******************************************/
/** err=1 ok=0                                       **/
int put_sub(FILE *fp, char *dt)
{
  if (EOF==fputs(dt, fp))
    return 1;
  if (EOF==fputs("\n", fp))
    return 1;
  return 0;
}

/** ǡ¸ ***************************************/
/** err=1 ok=0                                       **/
int data_save(char *fname)
{
  FILE *fp;
  JYU *jyu;
  char buff[10];

  if (0==(fp=fopen(fname, "w")))
    return 1;
  fputs("001\n", fp);

  jyu=jyu_end;
  while(jyu){
    if (jyu->del){
      jyu=jyu->pb;
      continue;
    }
    put_sub(fp, "---");
    sprintf(buff, "%d", jyu->key);
    put_sub(fp, buff);
    sprintf(buff, "%d", jyu->ji_atena);
    put_sub(fp, buff);
    sprintf(buff, "%d", jyu->ka_atena);
    put_sub(fp, buff);
    put_sub(fp, jyu->yomi);
    put_sub(fp, jyu->bkey);
    put_sub(fp, jyu->namae);
    put_sub(fp, jyu->umare);
    put_sub(fp, jyu->jitaku1);
    put_sub(fp, jyu->jitaku2);
    put_sub(fp, jyu->ji_yubin);
    put_sub(fp, jyu->ji_mail1);
    put_sub(fp, jyu->ji_mail2);
    put_sub(fp, jyu->ji_www);
    put_sub(fp, jyu->ji_tel);
    put_sub(fp, jyu->ji_keitai);
    put_sub(fp, jyu->ji_ren1);
    put_sub(fp, jyu->ji_ren2);
    put_sub(fp, jyu->ji_ren3);
    put_sub(fp, jyu->ji_ren4);
    put_sub(fp, jyu->ji_keisyou);
    put_sub(fp, jyu->kaisya1);
    put_sub(fp, jyu->kaisya2);
    put_sub(fp, jyu->ka_katagaki);
    put_sub(fp, jyu->ka_yubin);
    put_sub(fp, jyu->ka_mail1);
    put_sub(fp, jyu->ka_mail2);
    put_sub(fp, jyu->ka_www);
    put_sub(fp, jyu->ka_tel);
    put_sub(fp, jyu->ka_keitai);
    put_sub(fp, jyu->ka_keisyou);
    put_sub(fp, jyu->bikou);
    jyu=jyu->pb;
  }
  fclose(fp);
  return 0;
}

/** fget sub ******************************************/
/** err=1 ok=0                                       **/
int fget_sub(char *dt, int s, FILE *fp)
{
  fgets(dt, s, fp);
  if (0<strlen(dt))
    dt[strlen(dt)-1]='\0';
  return 0;
}

/** ǡɤ߹ ************************************/
/** err=1 ok=0                                       **/
int data_read(char *fname)
{
  FILE *fp;
  JYU jyu;
  char inbuf[256];

  if (0==(fp=fopen(fname, "r")))
    return 1;

  fgets(inbuf, sizeof(inbuf), fp);
  if (0!=strncmp("001", inbuf, 3)){  /*С󸡺*/
    fclose(fp);
    return 1;
  }

  while(NULL!=fgets(inbuf, sizeof(inbuf), fp)){
    if (0!=strncmp("---", inbuf, 3)){  /*ǡ*/
      fclose(fp);
      return 1;
    }
    memset(&jyu, 0, sizeof(JYU));
    fget_sub(inbuf, sizeof(inbuf), fp);
    jyu.key=atoi(inbuf);
    fget_sub(inbuf, sizeof(inbuf), fp);
    jyu.ji_atena=atoi(inbuf);
    fget_sub(inbuf, sizeof(inbuf), fp);
    jyu.ka_atena=atoi(inbuf);
    fget_sub(jyu.yomi, sizeof(jyu.yomi), fp);
    fget_sub(jyu.bkey, sizeof(jyu.bkey), fp);
    fget_sub(jyu.namae, sizeof(jyu.namae), fp);
    fget_sub(jyu.umare, sizeof(jyu.umare), fp);
    fget_sub(jyu.jitaku1, sizeof(jyu.jitaku1), fp);
    fget_sub(jyu.jitaku2, sizeof(jyu.jitaku2), fp);
    fget_sub(jyu.ji_yubin, sizeof(jyu.ji_yubin), fp);
    fget_sub(jyu.ji_mail1, sizeof(jyu.ji_mail1), fp);
    fget_sub(jyu.ji_mail2, sizeof(jyu.ji_mail2), fp);
    fget_sub(jyu.ji_www, sizeof(jyu.ji_www), fp);
    fget_sub(jyu.ji_tel, sizeof(jyu.ji_tel), fp);
    fget_sub(jyu.ji_keitai, sizeof(jyu.ji_keitai), fp);
    fget_sub(jyu.ji_ren1, sizeof(jyu.ji_ren1), fp);
    fget_sub(jyu.ji_ren2, sizeof(jyu.ji_ren2), fp);
    fget_sub(jyu.ji_ren3, sizeof(jyu.ji_ren3), fp);
    fget_sub(jyu.ji_ren4, sizeof(jyu.ji_ren4), fp);
    fget_sub(jyu.ji_keisyou, sizeof(jyu.ji_keisyou), fp);
    fget_sub(jyu.kaisya1, sizeof(jyu.kaisya1), fp);
    fget_sub(jyu.kaisya2, sizeof(jyu.kaisya2), fp);
    fget_sub(jyu.ka_katagaki, sizeof(jyu.ka_katagaki), fp);
    fget_sub(jyu.ka_yubin, sizeof(jyu.ka_yubin), fp);
    fget_sub(jyu.ka_mail1, sizeof(jyu.ka_mail1), fp);
    fget_sub(jyu.ka_mail2, sizeof(jyu.ka_mail2), fp);
    fget_sub(jyu.ka_www, sizeof(jyu.ka_www), fp);
    fget_sub(jyu.ka_tel, sizeof(jyu.ka_tel), fp);
    fget_sub(jyu.ka_keitai, sizeof(jyu.ka_keitai), fp);
    fget_sub(jyu.ka_keisyou, sizeof(jyu.ka_keisyou), fp);
    fget_sub(jyu.bikou, sizeof(jyu.bikou), fp);
    data_add(jyu);
  }

  fclose(fp);
  return 0;
}
